<?php
/*  Photoblog for DotClear
 *  Copyright (C) 2005  Julien Mudry
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

require_once dirname(__FILE__).'/../../../inc/libs/lib.image.php';
include_once(dirname(__FILE__).'/lib.installer.php');

$quality = 95;
$default_thumb_size = 90;
$default_sepia = 2;
$default_now_text = 'Vous &ecirc;tes ici';
$default_same_thumbs = 1;

$p_photo_sepia = $default_sepia;
$p_archive_month_chrono_order = 0;
$p_archive_cat_chrono_order = 0;
$p_thumb_width = $default_thumb_size;
$p_thumb_height = $default_thumb_size;
$p_now_text = $default_now_text;
$p_same_thumbs = $default_same_thumbs;
$p_photo_sepia_nav = $default_sepia;
$p_thumb_width_nav = $default_thumb_size;
$p_thumb_height_nav = $default_thumb_size;
$config_read = false;

class dcPhotoBlog {

	function readConfigFile()
	{
		global $p_photo_max_posts, $p_photo_sepia, $config_read, $p_archive_month_chrono_order, $p_archive_cat_chrono_order, $p_thumb_width, $p_thumb_height, $p_now_text, $p_same_thumbs, $p_photo_sepia_nav, $p_thumb_width_nav, $p_thumb_height_nav;
		global $default_sepia, $default_nav_thumbs, $default_thumb_size, $default_now_text, $default_same_thumbs;

		if (!$config_read) {
			$ini_file = DC_SHARE_DIR . '/photoblog/photoblog.ini';
			if (@file_exists($ini_file)) {
				$my_config = installer::loadPluginConfig('photoblog');
				$p_photo_sepia = $my_config['sp_photo_sepia'];
				$p_archive_month_chrono_order = $my_config['sp_archive_month_chrono_order'];
				$p_archive_cat_chrono_order = $my_config['sp_archive_cat_chrono_order'];
				$p_nav_nb_prev_thumbs = $my_config['sp_nav_nb_prev_thumbs'];
				$p_nav_nb_next_thumbs = $my_config['sp_nav_nb_next_thumbs'];
				$p_thumb_width = $my_config['sp_thumb_width'];
				$p_thumb_height = $my_config['sp_thumb_height'];
				$p_now_text = isset($my_config['sp_now_text']) ? $my_config['sp_now_text'] : '';
				$p_same_thumbs = isset($my_config['sp_same_thumbs']) ? $my_config['sp_same_thumbs'] : '';
				$p_photo_sepia_nav = isset($my_config['sp_photo_sepia_nav']) ? $my_config['sp_photo_sepia_nav'] : $my_config['sp_photo_sepia'];
				$p_thumb_width_nav = isset($my_config['sp_thumb_width_nav']) ? $my_config['sp_thumb_width_nav'] : $my_config['sp_thumb_width'];
				$p_thumb_height_nav = isset($my_config['sp_thumb_height_nav']) ? $my_config['sp_thumb_height_nav'] : $my_config['sp_thumb_height'];

				// Valeurs par défaut
				if (empty($p_nav_nb_prev_thumbs)) { $p_nav_nb_prev_thumbs = $default_nav_thumbs; }
				if (empty($p_nav_nb_next_thumbs)) { $p_nav_nb_next_thumbs = $default_nav_thumbs; }
				if (empty($p_thumb_width)) { $p_thumb_width = $default_thumb_size; }
				if (empty($p_thumb_height)) { $p_thumb_height = $default_thumb_size; }
				if (empty($p_now_text)) { $p_now_text = $default_now_text; }
				if (empty($p_same_thumbs)) { $p_same_thumbs = $default_same_thumbs; }
	
				$config_read = true;
			}
		}
	}

	function displayMonthArchiveURL($year = '', $month = '')
	{
		global $blog, $mode;
		if ($mode == 'photo_archive') {
			$comp_url = 'photo_archive/';
		} else {
			$comp_url = '';
		}

		if ($year == '') {
			$year = date('Y', $foo=key($bar=$blog->getAllDates()));
		}
		if ($month == '') {
			$month = date('m', $foo=key($bar=$blog->getAllDates()));
		}

		$year_month_string = $year . ( ($month <> '')? "/$month" : '' );

		printf($blog->front_url['cat'], $comp_url . $year_month_string);
	}

	function displayCatArchiveURL($cat_libelle_url)
	{
		global $blog, $mode;
		if ($mode == 'photo_archive') {
			$comp_url = 'photo_archive/';
		} else {
			$comp_url = '';
		}

		printf($blog->front_url['cat'], $comp_url . $cat_libelle_url);
	}

	function displayPhotoArchives()
	{
		global $cat_id_photo, $year, $month;

		dcPhotoBlog::readConfigFile();
		if (isset($cat_id_photo) && ($cat_id_photo != ''))
		{
			dcPhotoBlog::displayArchiveCategory();
		} else {
			dcPhotoBlog::displayArchiveMonth();
		}
	}

	function getPhotoArchiveMonths($block = '<ul>%s</ul>', $item = '<li>%s</li>')
	{
		global $arry_months, $blog, $year, $month, $cat_id_photo, $mode, $cat_id;

		if ($mode == 'photo_archive') {
			$comp_url = 'photo_archive/';
		} else {
			$comp_url = '';
		}
		$res = '';
		if ($cat_id == '') {
			$my_months = $arry_months;
		} else {
			$my_months = $blog->getAllDates('m','','','',$cat_id);
			$comp_url .= $cat_id . '/';
		}

		foreach ($my_months as $ts => $d)
		{
			$titre = dt::str('%B %Y', $ts);
			$url = sprintf($blog->front_url['cat'], $comp_url . date('Y', $ts) . '/' . date('m', $ts));
			$lien = '<a href="' . $url . '">%s</a>';
			if ($year == date('Y', $ts) && $month == date('m', $ts)) {
				$lien = '<span class="current">' . $lien . '</span>';
			}
			$res = sprintf($item, sprintf($lien, $titre)) . $res;
		}

		if (count($my_months) > 0) {
			printf($block, $res);
		}
	}

	function getPhotoArchiveCategories($block = '<ul>%s</ul>', $item = '<li>%s</li>')
	{
		global $blog, $cat_id_photo, $mode;

		if ($mode == 'photo_archive') {
			$comp_url = 'photo_archive/';
		} else {
			$comp_url = '';
		}
		$res = '';

		$rs_cat = $blog->getCat();

		if (!$rs_cat->isEmpty())
		{
			while (!$rs_cat->EOF())
			{
				if ($rs_cat->f('nb_post') > 0)
				{
					$titre = $rs_cat->f('cat_libelle');
					$id = $rs_cat->f('cat_libelle_url');
					$url = sprintf($blog->front_url['cat'], $comp_url . $id);
					$lien = '<a href="' . $url . '">%s</a>';
					if ($cat_id_photo == $id) {
						$lien = '<span class="current">' . $lien . '</span>';
					}
					$res = $res . sprintf($item, sprintf($lien, $titre));
				}
				$rs_cat->moveNext();
			}
			$rs_cat->moveStart();
		}

		if ($res != '') {
			printf($block, $res);
		}
	}

	function displayArchiveVignette($rs)
	{
		global $blog;

		$ts = strtotime($rs->f('post_dt'));
		$titre = $rs->f('post_titre');
		$id = $rs->f('post_id');

		$jour = dt::str('%A %e<br />%B %Y', $ts);
		$url = sprintf($blog->front_url['post'], date('Y', $ts), date('m', $ts), date('d', $ts), $id, $blog->str2url($titre));
		$image = dcPhotoBlog::getPostImageBWThumb($id, true);
		$lien_image = sprintf('<a href="%s" title="%s" style="background-image: url(%s);"></a>', $url, $titre, str_replace(' ', '%20', $image));
		printf('<div class="vignettes_archive">%s<br /><div class="vignettes">%s</div><a href="%s">%s</a></div>', $jour, $lien_image, $url, $titre);
	}

	function getArchiveTitle()
	{
		global $year, $month, $cat_id_photo, $blog, $cat_id, $con;

		if (($cat_id_photo != '') || ($cat_id != '')) {
			$my_cat = $cat_id_photo == '' ? $cat_id : $cat_id_photo;
			$SQL = 'SELECT cat_libelle FROM ' . $blog->t_categorie . ' WHERE cat_libelle_url = \'' . $my_cat . "'";
			$rs_cat = $con->select($SQL);

			$title = $rs_cat->f('cat_libelle');
			if ($year > 0 && $month == '') {
				$title .= ", $year";
			} else if ($year > 0 && $month > 0 && $month < 13) {
				$title .= ', ' . strtolower(dt::str('%B', strtotime("2000-$month-01"))) . " $year";
			}
		} else {
			$title = ucwords(dt::str('%B', strtotime("2000-$month-01"))) . ' ' . $year;
		}
		return $title;
	}

	function displayArchiveTitle($block='<div id="photo_archive_title"><h2>%s</h2></div>')
	{
		printf($block, dcPhotoBlog::getArchiveTitle());
	}

	function displayArchiveMonth()
	{
		global $arry_months, $year, $month, $blog, $con, $p_archive_month_chrono_order;

		if (($year == '') && ($month == '')) { $keys = array_keys($arry_months); $ts = $keys[0]; $year = date('Y', $ts); $month = date('m', $ts); }
		if ($year == '') { $year = date('Y'); }
		if ($month == '') { $month = date('m'); }

		dcPhotoBlog::displayArchiveTitle();
		printf('<div id="photo_archive">');

		$year = $con->escapeStr($year);
		$month = $con->escapeStr($month);

		$SQL = 'select post_id, post_dt, post_titre from ' . $blog->t_post . " where post_dt between '$year-$month-01 00:00:00' and '$year-$month-31 23:59:59' and post_pub = '1' order by post_dt";
		if (!$p_archive_month_chrono_order) { $SQL .= ' desc'; }
		$rs = $con->select($SQL);
		while (!$rs->EOF()) {
			dcPhotoBlog::displayArchiveVignette($rs);
			$rs->moveNext();
		}
		printf('</div>');

		printf('<div id="sidebar_archive">');
		dcPhotoBlog::getPhotoArchiveMonths();
		printf('</div>');
	}

	function displayArchiveCategory()
	{
		global $cat_id_photo, $blog, $con, $p_photo_max_posts, $year, $month, $p_archive_cat_chrono_order;
		dcPhotoBlog::readConfigFile();

		dcPhotoBlog::displayArchiveTitle();
		printf('<div id="photo_archive">');

		$rs_cat = $blog->getCat($cat_id_photo);
		$SQL = 'select post_id, post_dt, post_titre from ' . $blog->t_post . ' where cat_id = \'' . $rs_cat->f('cat_id_photo') . "' and post_pub = '1'";
		if ($year > 0 && $month == '') {
			$SQL .= " and post_dt between '$year-01-01 00:00:00' and '$year-12-31 23:59:59' ";
		} else if ($year > 0 && $month > 0 && $month < 13) {
			$SQL .= " and post_dt between '$year-$month-01 00:00:00' and '$year-$month-31 23:59:59' ";
		}
		$SQL .= "order by post_dt desc";
		if ($p_photo_max_posts > 0) { $SQL .= ' limit ' . $p_photo_max_posts; }
		$rs = $con->select($SQL);
		if ($p_archive_cat_chrono_order) {
		$rs->moveEnd();
			while (!$rs->BOF()) {
				dcPhotoBlog::displayArchiveVignette($rs);
				if (!$rs->movePrev()) { break; }
			}
		} else {
			while (!$rs->EOF()) {
				dcPhotoBlog::displayArchiveVignette($rs);
				if (!$rs->moveNext()) { break; }
			}
		}
		printf('</div>');

		printf('<div id="sidebar_archive">');
		dcPhotoBlog::getPhotoArchiveCategories();
		dcPhotoBlog::getPhotoArchiveMonths();
		printf('</div>');
	}

	function getPostImage($post_id)
	{
		global $blog;

		$post = $blog->getPostByID($post_id);
		if (!$post->isEmpty()) {
			$img_src_regexp = '/<img .*?src="(.+?)"/i';
			if (preg_match($img_src_regexp, $post->f('post_chapo'), $matches)) {
				return $matches[1];
			} else if (preg_match($img_src_regexp, $post->f('post_content'), $matches)) {
				return $matches[1];
			}
		}
		return false;
	}

	function getImageThumbFileName($imageFileName, $isBW, $isForArchive) 
	{
		$suffix = 'photo';
		if ($isBW) {
			$suffix .= 'bw';
		}
		if (!$isForArchive) {
			$suffix .= 'nav';
		}
		return preg_replace('/^(.*)([.]\\w+)$/', '$1.' . $suffix . 'TN__$2', $imageFileName);
	}

	function getPostImageColorThumb($post_id, $is_for_archive)
	{
		global $p_thumb_width, $p_thumb_height, $p_photo_sepia;
		global $p_thumb_width_nav, $p_thumb_height_nav, $p_photo_sepia_nav;
		dcPhotoBlog::readConfigFile();

		if ($is_for_archive) {
			$thumb_width = $p_thumb_width;
			$thumb_height = $p_thumb_height;
			$thumb_sepia = $p_photo_sepia;
		} else {
			$thumb_width = $p_thumb_width_nav;
			$thumb_height = $p_thumb_height_nav;
			$thumb_sepia = $p_photo_sepia_nav;
		}

		if ($image = dcPhotoBlog::getPostImage($post_id)) {
			if (preg_match('!' . dc_img_url . '(.+)!i', $image)) {
				$dc_thumb = preg_replace('/^(.*)([.]\\w+)$/', '$1.TN__$2', $image);
				$photo_thumb = dcPhotoBlog::getImageThumbFileName($image, false, $is_for_archive);
				$photo_bwthumb = dcPhotoBlog::getImageThumbFileName($image, true, $is_for_archive);
				dcPhotoBlog::createBWPhotoThumb($image, $photo_bwthumb, $thumb_width, $thumb_height, $thumb_sepia);
				if (dcPhotoBlog::createPhotoThumb($image, $photo_thumb, $thumb_width, $thumb_height)) {
					return $photo_thumb;
				} else {
					return $dc_thumb;
				}
			}
		}
		return false;
	}

	function getPostImageBWThumb($post_id, $is_for_archive)
	{
		global $p_thumb_width, $p_thumb_height, $p_photo_sepia;
		global $p_thumb_width_nav, $p_thumb_height_nav, $p_photo_sepia_nav;
		dcPhotoBlog::readConfigFile();

		if ($is_for_archive) {
			$thumb_width = $p_thumb_width;
			$thumb_height = $p_thumb_height;
			$thumb_sepia = $p_photo_sepia;
		} else {
			$thumb_width = $p_thumb_width_nav;
			$thumb_height = $p_thumb_height_nav;
			$thumb_sepia = $p_photo_sepia_nav;
		}

		if ($image = dcPhotoBlog::getPostImage($post_id)) {
			if (preg_match('!' . dc_img_url . '(.+)!i', $image)) {
				$dc_thumb = preg_replace('/^(.*)([.]\\w+)$/', '$1.TN__$2', $image);
				$photo_thumb = dcPhotoBlog::getImageThumbFileName($image, false, $is_for_archive);
				$photo_bwthumb = dcPhotoBlog::getImageThumbFileName($image, true, $is_for_archive);
				dcPhotoBlog::createPhotoThumb($image, $photo_thumb, $thumb_width, $thumb_height);
				if (dcPhotoBlog::createBWPhotoThumb($image, $photo_bwthumb, $thumb_width, $thumb_height, $thumb_sepia)) {
					return $photo_bwthumb;
				} else {
					return $dc_thumb;
				}
			}
		}
		return false;
	}

	function getLastXPostLinks($currentTS, $nb_posts, $dir)
	{
		global $blog, $con;
		global $p_same_thumbs;
		$result = false;
		dcPhotoBlog::readConfigFile();

		if ($dir == 0) {

			$reqPlus = '';
			if ($blog->pub_mode !== NULL) {
				$reqPlus .= 'AND post_pub = '.$blog->pub_mode.' ';
			}

			if ($blog->lang !== NULL) {
				$reqPlus .= 'AND post_lang = \''.$blog->con->escapeStr($blog->lang).'\' ';
			}
			$strReq = 'SELECT post_id, post_titre, post_dt FROM ' . $blog->t_post . ' WHERE UNIX_TIMESTAMP(post_dt) = \'' . $currentTS . '\' ' . $reqPlus . ' ORDER BY post_dt LIMIT 0,1';
			$rs = $con->select($strReq);
				if (!$rs->isEmpty()) {
					$id = $rs->f('post_id');
					$titre = $rs->f('post_titre');
					$date = $rs->f('post_dt');
					$ts = strtotime($date);
					$url = sprintf($blog->front_url['post'], date('Y', $ts), date('m', $ts), date('d', $ts), $id, $blog->str2url($titre));
					if ($p_same_thumbs > 0) {
						$thumb = dcPhotoBlog::getPostImageColorThumb($id, true);
					} else {
						$thumb = dcPhotoBlog::getPostImageColorThumb($id, false);
					}

					$result[0] = array('id' => $id, 'titre' => $titre, 'url' => $url, 'thumb' => $thumb);
				}
		} else {

			for ($i = 0; $i < $nb_posts; $i++) {
				$rs = $blog->getNextID($currentTS, $dir);
				if (!$rs->isEmpty()) {
					$id = $rs->f('post_id');
					$titre = $rs->f('post_titre');
					$date = $rs->f('post_dt');
					$ts = strtotime($date);
					$url = sprintf($blog->front_url['post'], date('Y', $ts), date('m', $ts), date('d', $ts), $id, $blog->str2url($titre));
					if ($p_same_thumbs > 0) {
						$thumb = dcPhotoBlog::getPostImageBWThumb($id, true);
						$thumb = dcPhotoBlog::getPostImageBWThumb($id, true);
					} else {
						$thumb = dcPhotoBlog::getPostImageBWThumb($id, false);
						$thumb = dcPhotoBlog::getPostImageBWThumb($id, false);
					}

					$result[$i] = array('id' => $id, 'titre' => $titre, 'url' => $url, 'thumb' => $thumb);
					$currentTS = $ts;
				} else {
					break;
				}
			}
		}

		if ($dir < 0 && is_array($result)) {
			$result = array_reverse($result);
		}

		return $result;
	}

	function displayNavigation($currentTS, $nb_posts, $dir)
	{
		global $p_now_text;

		$post_links = dcPhotoBlog::getLastXPostLinks($currentTS, $nb_posts, $dir);
		if ($post_links) {
			echo '<table><tr style="text-align: center;">';
			for ($i = 0; $i < count($post_links); $i++) {
				$s = '<td><a href="%3$s" title="%2$s">';
				if ($dir == 0) {
					$s = "<td>$p_now_text</td>";
				} else if ($dir < 0) {
					for ($j = 0; $j < count($post_links) - $i; $j++) {
						$s = $s . '&lt;';
					}
				} else {
					for ($j = 0; $j <= $i; $j++) {
						$s = $s . '&gt;';
					}
				}
				if ($dir != 0) { $s = $s . '</a></td>'; }
				$post_details = current($post_links);
				printf($s, $post_details['id'], $post_details['titre'], $post_details['url']);
				next($post_links);
			}
			echo '</tr><tr>';
			reset($post_links);
			for ($i = 0; $i < count($post_links); $i++) {
				echo '<td class="vignettes_nav">';
				$post_details = current($post_links);
				if ($post_details['thumb']) {
					if ($dir == 0) {
						$s = '<img src="%4$s" alt="Vignette de l\'image courante." />';
					} else {
						$s = '<a href="%3$s" title="%2$s" style="background-image: url(%4$s);"></a>';
					}
					printf($s, $post_details['id'], $post_details['titre'], $post_details['url'], str_replace(' ', '%20', $post_details['thumb']));
				}
				echo '</td>';
				next($post_links);
			}
			echo '</tr></table>';
		}
	}

	function createBWPhotoThumb($uri, $file, $w=90, $h=90, $sepia_toning=2) {
		global $quality, $default_thumb_size, $default_sepia;

		if (empty($w)) { $w = $default_thumb_size; }
		if (empty($h)) { $h = $default_thumb_size; }

		dcPhotoBlog::readConfigFile();
		$src_rel = preg_replace('!' . dc_img_url . '!i', '', $uri);
		$dest_rel = preg_replace('!' . dc_img_url . '!i', '', $file);

		$img_p = dcPhotoBlog::getImagePath();

		$uri = $img_p . '/' . $src_rel;
		$file = $img_p . '/' . $dest_rel;

		if (file_exists($file)) {
			return true;
		}

		if (!file_exists($uri)) {
			return false;
		}

		if (($size = @getimagesize($uri)) === false) {
			return false;
		}

		$origW = $size[0];
		$origH = $size[1];
		$type = $size[2];

		if ($type == '1') {
			$function = 'imagecreatefromgif';
		} elseif ($type == '2') {
			$function = 'imagecreatefromjpeg';
		} elseif ($type == '3') {
			$function = 'imagecreatefrompng';
		} else {
			return false;
		}

		if (!function_exists($function)) {
			return false;
		}

		if (($img = @$function($uri)) == false) {
			return false;
		}

		if ($w < $h) {  // Portrait output
			$srcW = round($origH * ($w / $h));
			$srcH = $origH;
			$srcX = round(($origW - $srcW) / 2);
			$srcY = 0;
		} elseif ($w > $h) { // Landscape output
			$srcW = $origW;
			$srcH = round($origW * ($h / $w));
			$srcX = 0;
			$srcY = round(($origH - $srcH) / 2);
		} elseif (($origW <= $origH) and ($w = $h)) { // Square output, portrait or square input
			$srcW = $origW;
			$srcH = round($origW * ($h / $w));
			$srcX = 0;
			$srcY = round(($origH - $srcH) / 2);
		} elseif (($origW > $origH) and ($w = $h)) { // Square output, landscape input
			$srcW = round($origH * ($w / $h));
			$srcH = $origH;
			$srcX = round(($origW - $srcW) / 2);
			$srcY = 0;
		}

		$create_function = images::checkTrueColor() ? 'imagecreatetruecolor' : 'imagecreate';

		if (($img2 = $create_function($w, $h * 2)) === false) {
			return false;
		}

		imagecopyresampled($img2, $img, 0, 0, $srcX, $srcY, $w, $h, $srcW, $srcH);

		// Does the user wants some kind of sepia toning for his thumbnails?
		if ($sepia_toning > 0) {
			// convert to a palette
			imagetruecolortopalette($img, 1, 256);

			// init Lagrange denominators and curve points
			switch($sepia_toning) {
			case 2:
				// Sepia 1 (according to http://www.epaperpress.com/psphoto/bawClassicTones.html )
				$cr = array( array(0, 0), array(66, 79), array(127, 151), array(194, 206), array(255, 255) );
				$cg = array( array(0, 0), array(66, 63), array(127, 121), array(194, 190), array(255, 255) );
				$cb = array( array(0, 0), array(66, 48), array(127,  91), array(194, 174), array(255, 255) );
				break;

			case 3:
				// Sepia 2 (according to http://www.epaperpress.com/psphoto/bawClassicTones.html )
				$cr = array( array(0, 0), array(61, 82), array(128, 157), array(189, 214), array(255, 255) );
				$cg = array( array(0, 0), array(61, 55), array(128, 121), array(189, 185), array(255, 255) );
				$cb = array( array(0, 0), array(61, 22), array(128,  71), array(189, 145), array(255, 255) );
				break;

			case 4:
				// Sepia 3 (according to http://www.epaperpress.com/psphoto/bawClassicTones.html )
				$cr = array( array(0, 0), array(67, 98), array(127, 165), array(192, 214), array(255, 255) );
				$cg = array( array(0, 0), array(67, 54), array(127, 116), array(192, 185), array(255, 255) );
				$cb = array( array(0, 0), array(67, 19), array(127,  84), array(192, 171), array(255, 255) );
				break;

			case 5:
				// Selenium (according to http://www.epaperpress.com/psphoto/bawClassicTones.html )
				$cr = array( array(0, 0), array(64, 79), array(127, 139), array(191, 198), array(255, 255) );
				$cg = array( array(0, 0), array(64, 59), array(127, 123), array(191, 188), array(255, 255) );
				$cb = array( array(0, 0), array(61, 61), array(127, 133), array(191, 197), array(255, 255) );
				break;

			case 6:
				// Silver (according to http://www.epaperpress.com/psphoto/bawClassicTones.html )
				$cr = array( array(0, 0), array(64, 57), array(128, 119), array(191, 188), array(255, 255) );
				$cg = array( array(0, 0), array(64, 65), array(128, 130), array(191, 192), array(255, 255) );
				$cb = array( array(0, 0), array(64, 67), array(128, 129), array(191, 192), array(255, 255) );
				break;

			case 7:
				// Cyanotype (according to http://www.epaperpress.com/psphoto/bawClassicTones.html )
				$cr = array( array(0, 0),                array(129,  25), array(193, 120), array(255, 255) );
				$cg = array( array(0, 0),                array(129, 135), array(193, 204), array(255, 255) );
				$cb = array( array(0, 0),                array(129, 220), array(193, 250), array(255, 255) );
				break;

			case 8:
				// Platinum (according to http://www.epaperpress.com/psphoto/bawClassicTones.html )
				$cr = array( array(0, 0), array(63, 75), array(127, 129), array(191, 193), array(255, 255) );
				$cg = array( array(0, 0),                                                  array(255, 255) );
				$cb = array( array(0, 0), array(63, 51), array(127, 112), array(191, 176), array(255, 255) );
				break;

			case 9:
				// Palladium (according to http://www.epaperpress.com/psphoto/bawClassicTones.html )
				$cr = array( array(0, 0), array(64, 67), array(126, 143), array(195, 213), array(255, 255) );
				$cg = array( array(0, 0), array(64, 60), array(126, 122), array(195, 192), array(255, 255) );
				$cb = array( array(0, 0), array(64, 47), array(126, 103), array(195, 173), array(255, 255) );
				break;

			case 10:
				// Silver Gelatin (according to http://www.epaperpress.com/psphoto/bawClassicTones.html )
				$cr = array( array(0, 0), array(64, 79), array(127, 148), array(193, 213), array(255, 255) );
				$cg = array( array(0, 0), array(64, 59), array(127, 123), array(193, 188), array(255, 255) );
				$cb = array( array(0, 0), array(64, 34), array(127,  93), array(193, 157), array(255, 255) );
				break;

			default:
				// Black and white
				$cr = array( array(0, 0),                                                  array(255, 255) );
				$cg = array( array(0, 0),                                                  array(255, 255) );
				$cb = array( array(0, 0),                                                  array(255, 255) );
				break;
			}

			$dr = array(1, 1, 1, 1, 1); $dg = array(1, 1, 1, 1, 1); $db = array(1, 1, 1, 1, 1);

			for ($i = 0; $i < count($cr); $i++) {
				for ($j = 0; $j < count($cr); $j++) {
					if ($j == $i) { continue; }
					$dr[$i] = $dr[$i] * ($cr[$i][0] - $cr[$j][0]);
				}
			}
			for ($i = 0; $i < count($cg); $i++) {
				for ($j = 0; $j < count($cg); $j++) {
					if ($j == $i) { continue; }
					$dg[$i] = $dg[$i] * ($cg[$i][0] - $cg[$j][0]);
				}
			}
			for ($i = 0; $i < count($cb); $i++) {
				for ($j = 0; $j < count($cb); $j++) {
					if ($j == $i) { continue; }
					$db[$i] = $db[$i] * ($cb[$i][0] - $cb[$j][0]);
				}
			}

			// loop through palette
			for ($x = 0; $x < imagecolorstotal($img); $x++) {
				$a = array();
				$a = imagecolorsforindex($img, $x);

				$r = 0; $g = 0; $b = 0;
				// calc a grayscale value
				$gs = intval(($a['red']  / 3) + ($a['green'] / 3) + ($a['blue'] / 3));

				// Lagrange polynomial interpolation
				for ($i = 0; $i < count($cr); $i++) {
					$temp = $cr[$i][1];
					for ($j = 0; $j < count($cr); $j++) {
						if ($j == $i) { continue; }
						$temp = $temp * ($gs - $cr[$j][0]);
					}
					$r = $r + $temp / $dr[$i];
				}

				for ($i = 0; $i < count($cg); $i++) {
					$temp = $cg[$i][1];
					for ($j = 0; $j < count($cg); $j++) {
						if ($j == $i) { continue; }
						$temp = $temp * ($gs - $cg[$j][0]);
					}
					$g = $g + $temp / $dg[$i];
				}

				for ($i = 0; $i < count($cb); $i++) {
					$temp = $cb[$i][1];
					for ($j = 0; $j < count($cb); $j++) {
						if ($j == $i) { continue; }
						$temp = $temp * ($gs - $cb[$j][0]);
					}
					$b = $b + $temp / $db[$i];
				}

				imagecolorset($img, $x, $r, $g, $b);
			}

		}
		imagecopyresampled($img2, $img, 0, $h, $srcX, $srcY, $w, $h, $srcW, $srcH);

		if (!is_dir(dirname($file))) {
			$dmod = fileperms(dirname(dirname($file)));
			if (@mkdir(dirname($file), $dmod) === false) {
				return false;
			}
			chmod(dirname($file), $dmod);
		}

		if ($type == '1') {
			$endfunction = 'imagegif';
		} elseif ($type == '2') {
			$endfunction = 'imagejpeg';
		} elseif ($type == '3') {
			$endfunction = 'imagepng';
		} else {
			return false;
		}

		if (!function_exists($function)) {
			return false;
		}

		if (@$endfunction($img2, $file, $quality) === false) {
			return false;
		}

		chmod($file, fileperms(dirname($file)) & ~0111);

		imagedestroy($img);
		imagedestroy($img2);
		return true;
	}

	function createPhotoThumb($uri, $file, $w=90, $h=90) {
		global $quality, $default_thumb_size;

		if (empty($w)) { $w = $default_thumb_size; }
		if (empty($h)) { $h = $default_thumb_size; }

		$src_rel = preg_replace('!' . dc_img_url . '!i', '', $uri);
		$dest_rel = preg_replace('!' . dc_img_url . '!i', '', $file);

		$img_p = dcPhotoBlog::getImagePath();

		$uri = $img_p . '/' . $src_rel;
		$file = $img_p . '/' . $dest_rel;

		if (file_exists($file)) {
			return true;
		}

		if (!file_exists($uri)) {
			return false;
		}

		if (($size = @getimagesize($uri)) === false) {
			return false;
		}

		$origW = $size[0];
		$origH = $size[1];
		$type = $size[2];

		if ($type == '1') {
			$function = 'imagecreatefromgif';
		} elseif ($type == '2') {
			$function = 'imagecreatefromjpeg';
		} elseif ($type == '3') {
			$function = 'imagecreatefrompng';
		} else {
			return false;
		}

		if (!function_exists($function)) {
			return false;
		}

		if (($img = @$function($uri)) == false) {
			return false;
		}

		if ($w < $h) {  // Portrait output
			$srcW = round($origH * ($w / $h));
			$srcH = $origH;
			$srcX = round(($origW - $srcW) / 2);
			$srcY = 0;
		} elseif ($w > $h) { // Landscape output
			$srcW = $origW;
			$srcH = round($origW * ($h / $w));
			$srcX = 0;
			$srcY = round(($origH - $srcH) / 2);
		} elseif (($origW <= $origH) and ($w = $h)) { // Square output, portrait or square input
			$srcW = $origW;
			$srcH = round($origW * ($h / $w));
			$srcX = 0;
			$srcY = round(($origH - $srcH) / 2);
		} elseif (($origW > $origH) and ($w = $h)) { // Square output, landscape input
			$srcW = round($origH * ($w / $h));
			$srcH = $origH;
			$srcX = round(($origW - $srcW) / 2);
			$srcY = 0;
		}

		$create_function = images::checkTrueColor() ? 'imagecreatetruecolor' : 'imagecreate';

		if (($img2 = $create_function($w, $h)) === false) {
			return false;
		}

		imagecopyresampled($img2, $img, 0, 0, $srcX, $srcY, $w, $h, $srcW, $srcH);

		if (!is_dir(dirname($file))) {
			$dmod = fileperms(dirname(dirname($file)));
			if (@mkdir(dirname($file), $dmod) === false) {
				return false;
			}
			chmod(dirname($file), $dmod);
		}

		if ($type == '1') {
			$endfunction = 'imagegif';
		} elseif ($type == '2') {
			$endfunction = 'imagejpeg';
		} elseif ($type == '3') {
			$endfunction = 'imagepng';
		} else {
			return false;
		}

		if (!function_exists($function)) {
			return false;
		}

		if (@$endfunction($img2, $file, $quality) === false) {
			return false;
		}

		chmod($file, fileperms(dirname($file)) & ~0111);

		imagedestroy($img);
		imagedestroy($img2);
		return true;
	}

	function getImagePath()
	{
		$img_p = dc_img_root;
		$img_p = path::real($img_p);

		if ($img_p == '') {
			preg_match('$' . dc_app_url . '/(.*)$', dc_img_root, $matches);
			$image_dir = isset($matches[1]) ? $matches[1] : '';
			if ($image_dir == '') {
				// Woops... couldn't find the directory name for the images,
				// defaulting to images
				$image_dir = 'images/';
			}
			if ($image_dir[strlen($image_dir) - 1] != '/') {
				$image_dir = $image_dir . '/';
			}
			$img_p = dirname(__FILE__) . '/../../../' . $image_dir;
			$img_p = path::real($img_p);
		}

		return $img_p;

	}

	function displayVerticalNav($currentTS, $nb_posts, $dir)
	{
		global $p_now_text;

		$post_links = dcPhotoBlog::getLastXPostLinks($currentTS, $nb_posts, $dir);
		if ($post_links) {
			end($post_links);
			for ($i = 0; $i < count($post_links); $i++) {
				$post_details = current($post_links);
				if ($post_details['thumb']) {
					if ($dir == 0) {
						echo '<li class="vignettes_nav current">';
						$s = '<img src="%4$s" alt="Vignette de l\'image courante." />';
					} else {
						echo '<li class="vignettes_nav">';
						$s = '<a href="%3$s" title="%2$s" style="background-image: url(%4$s);"></a>';
					}
					printf($s, $post_details['id'], $post_details['titre'], $post_details['url'], $post_details['thumb']);
				}
				echo '</li>';
				prev($post_links);
			}
			reset($post_links);
		}
	}


}

?>
